import urllib.request
import json

PostUrl = "" 
method = "POST"
headers = {"Content-Type" : "application/json"}

# POST先のURLを設定する関数
# 例 "http://shimodaPi400/setTemPreHum.php"
def setUrl(url):
    global PostUrl
    PostUrl = url

# 指定されたurlにPOSTでJSONデータを送信する関数
# 応答コードと応答のBODYを表示する
# 引数:辞書オブジェクト
def postJson(objDic):
#objDic をJSONに変換する,結果はjson_dataに入る
    json_data = json.dumps(objDic, ensure_ascii=False).encode("utf-8")
    # httpリクエストを準備してPOST
    # リスクエストデータを作る(ヘッダとボディの文字列)
    # https://docs.python.org/ja/3/howto/urllib2.html
    request = urllib.request.Request(PostUrl, data=json_data, method=method, headers=headers)

    # Webサーバに送信(with を使うとcloseを書かなくても良い)する
    # withを使用すると、何かの処理の開始時と終了時に必須の処理を絶対に実行してくれる
    # as で要求結果はresponseに入る　responseの中身：code, body)
    with urllib.request.urlopen(request) as response:
        response_body = response.read().decode("utf-8")
    # code, bodyを表示する
    print(response.getcode())
    print(response_body)

# このファイルが実行された時だけ実施される(動作確認用)
if __name__ == '__main__':
    setUrl("http://shimodaPi400/setTemPreHum.php")
    obj = {"温度": 15.83, "気圧": 1017.57, "湿度": 35.89}
    postJson(obj)
